<?php
/**********************************************************************************
* SMFShop item                                                                    *
***********************************************************************************
* SMFShop: Shop MOD for Simple Machines Forum                                     *
* =============================================================================== *
* Software Version:           SMFShop 3.0 (Build 12)                              *
* $Date:: 2008-5-18														                          $ *
* $Id:: Steal.php 79 2007-01-18 08:26:55Z daniel15                              $ *
* Software by:                DanSoft Australia (http://www.dansoftaustralia.net/)*
* Copyright 2005-2007 by:     DanSoft Australia (http://www.dansoftaustralia.net/)*
* Support, News, Updates at:  http://www.dansoftaustralia.net/                    *
*                                                                                 *
* Forum software by:          Simple Machines (http://www.simplemachines.org)     *
* Copyright 2006-2007 by:     Simple Machines LLC (http://www.simplemachines.org) *
*           2001-2006 by:     Lewis Media (http://www.lewismedia.com)             *
***********************************************************************************
* This program is free software; you may redistribute it and/or modify it under   *
* the terms of the provided license as published by Simple Machines LLC.          *
*                                                                                 *
* This program is distributed in the hope that it is and will be useful, but      *
* WITHOUT ANY WARRANTIES; without even any implied warranty of MERCHANTABILITY    *
* or FITNESS FOR A PARTICULAR PURPOSE.                                            *
*                                                                                 *
* See the "license.txt" file for details of the Simple Machines license.          *
* The latest version of the license can always be found at                        *
* http://www.simplemachines.org.                                                  *
**********************************************************************************/

if (!defined('SMF'))
	die('Hacking attempt...');

class item_StealLoggedInTime extends itemTemplate
{
	function getItemDetails()
	{
		$this->authorName = 'Eric Vernon';
		$this->authorWeb = 'http://www.stupidforumtricks.com/';
		$this->authorEmail = 'etadpole23_2@yahoo.com';

		$this->name = 'Steal Logged in Time';
		$this->desc = 'Try to steal logged in time from another user!';
		$this->price = 225;
		
		$this->require_input = true;
		$this->can_use_item = true;

# Note:
# This was based off of the Steal Credits item; Steal.php; created by Daniel15
#
# Explanation of variables:
# $item_info[1] is the probability of a successful steal
# $item_info[2] is the amount of time to steal, in seconds
# $item_info[3] is the amount of karma to lose in an successful steal
# $item_info[4] is the amount of karma to lose after an UNsuccessful steal
# $karma is the name for the karma (e.g., "Reputation")
# $user is the victim
# $ID_MEMBER is the robber
# $return_message is a cumulative message that will be returned to the robber; added to as we chug along
#
# Thanks for using my item :-)

	}

	function getAddInput()
	{
		global $db_prefix;

				# What is the karma called?  (Comment out or delete if you want to save a query)
			$result = db_query("
				SELECT *
				FROM {$db_prefix}settings
				WHERE variable = 'karmaLabel'", __FILE__, __LINE__);
			$array = mysql_fetch_assoc($result);
				$karma = $array['value'];
			$last_char = substr($karma, -1);
				if ($last_char == ":" || $last_char == "-" ) {
					$karma = substr($karma, 0, -1);
					}
				# Do not comment out or delete below this line!!!

				# Did the admin comment out the above section?
					if ( is_null($karma) )
						$karma = 'karma';		


		global $item_info;
		if ($item_info[1] == 0) $item_info[1] = 50;
		if ($item_info[2] == 0) $item_info[2] = 3600;
		if ($item_info[3] == 0) $item_info[3] = 5;
		if ($item_info[4] == 0) $item_info[4] = 10;
		return 'What is the probability of a successful steal?<br /><input type="text" name="info1" 						value="' . $item_info[1]  . '" />%<br /><br />
						How much time should this item steal, in seconds?  <br /> <input type="text" name="info2" value="' . $item_info[2] . '" /> seconds
						<div class="smalltext">If the victim does not have enough logged in time, they will simply be set to zero (no negatives).</div><br /><br />
					You can also modify the robber\'s ' . $karma. '<br />
					<input type="text" name="info3" value="' . $item_info[3] . '" /> ' . $karma . ' goes for successful steals.<br />
					<input type="text" name="info4" value="' . $item_info[4] . '" /> ' . $karma . ' is taken for failed steals.
					<div class="smalltext">Don\'t put negative numbers here, or else you might get unexpected SQL errors!</div>';
	}

	function getUseInput()
	{
		global $context, $scripturl, $settings, $txt;
		return 'Steal time from: <input type="text" name="username" size="50" />
				<a href="' . $scripturl . '?action=findmember;input=username;quote=0;sesc=' . $context['session_id'] . '" onclick="return reqWin(this.href, 350, 400);"><img src="' . $settings['images_url'] . '/icons/assist.gif" border="0" alt="' . $txt['find_members'] . '" /> Find Member</a><br />';
	}

	function onUse()
	{
		global $db_prefix, $ID_MEMBER, $item_info, $context, $txt;

				# What is the karma called?  (Comment out or delete if you want to save a query)
			$result = db_query("
				SELECT *
				FROM {$db_prefix}settings
				WHERE variable = 'karmaLabel'", __FILE__, __LINE__);
			$array = mysql_fetch_assoc($result);
				$karma = $array['value'];
			$last_char = substr($karma, -1);
				if ($last_char == ":" || $last_char == "-" ) {
					$karma = substr($karma, 0, -1);
					}
				# Do not comment out or delete below this line!!!

				# Did the admin comment out the above section?
					if ( is_null($karma) )
						$karma = 'karma';		
		
		// Check some inputs
		if (!isset($_POST['username']) || $_POST['username'] == '') die('ERROR: Please enter a username to steal from!');
		
		// This code from PersonalMessage.php5. It trims the " characters off the membername posted, 
		// and then puts all names into an array
		$_POST['username'] = strtr($_POST['username'], array('\\"' => '"'));
		preg_match_all('~"([^"]+)"~', $_POST['username'], $matches);
		$userArray = array_unique(array_merge($matches[1], explode(',', preg_replace('~"([^"]+)"~', '', $_POST['username']))));
		
		// We only want the first memberName found
		$user = $userArray[0];
		
		// Get a random number between 0 and 100
		$try = mt_rand(0, 100);

		// If successful
		# (Recall the % of success was stored in info[1])
		if ($try < $item_info[1])
		{

			// Get victim's time
			$result = db_query("
				SELECT totalTimeLoggedIn
				FROM {$db_prefix}members
				WHERE memberName = '{$user}'", __FILE__, __LINE__);

			// If user doesn't exist
			if (mysql_num_rows($result) == 0)
				die('ERROR: The specified user doesn\'t exist!  Egad!');

			$row = mysql_fetch_assoc($result);

			# Does the victim have as much time as the item specifies?
			# Because the totalTimeLoggedIn field of the members table is unsigned; users cannot go negative
			# I wouldn't advise changing it to signed; because you would run the risk of users hitting the limit of the field (unsigned fields can store twice as high numbers as signed fields)

			if ($item_info[2] > $row['totalTimeLoggedIn'] ) {
				$original = $item_info[2];
				$item_info[2] = $row['totalTimeLoggedIn'];
				}
			$steal_amount = $item_info[2];

			# Reduce the victim's sperm count
			$result = db_query("
				UPDATE {$db_prefix}members
				SET totalTimeLoggedIn = totalTimeLoggedIn - {$steal_amount}
				WHERE memberName = '{$user}'
				LIMIT 1", __FILE__, __LINE__);
			//...and give to robber
			$result = db_query("
				UPDATE {$db_prefix}members
				SET totalTimeLoggedIn = totalTimeLoggedIn + {$steal_amount}
				WHERE ID_MEMBER = {$ID_MEMBER}
				LIMIT 1", __FILE__, __LINE__);

					# Original only set if victim didn't have enough log time
			if ( isset($original))
				$return_message .= 'Steal successful, although the victim didn\'t have as much time as the item was capable of taking.  You have gained ' . $steal_amount . ' seconds!';
			else
				$return_message .= 'Successfully stole ' . $steal_amount . ' seconds from ' . $user . '! Sucker!';
			# How much are we reducing the karma by for success?
			# No sense in a query if we aren't doing anything....
				if ($item_info[3] != 0) {
			# 
			// If reducing Karma doesn't work, replace
			// 'karmaBad = karmaBad + 10' with 'karmaGood = karmaGood - 10'
			$result = db_query("
				UPDATE {$db_prefix}members
				SET karmaBad = karmaBad + {$item_info[3]}
				WHERE ID_MEMBER = {$ID_MEMBER}", __FILE__, __LINE__);	
				$return_message .= ' <br />Unfortunately, you have lost ' . $item_info[3] . ' ' . $karma; 
				}
	# Right-o; let's send a message
	# (Borrowed from dan's trade centre script)
		// Who is sending the IM
		$pmfrom = array(
			'id' => $ID_MEMBER,
			'name' => $context['user']['name'],
			'username' => $context['user']['username']
		);

		// Who is receiving the IM		
		$pmto = array(
			'to' => array($user),
			'bcc' => array()
		);
		// The message subject
		$subject = sprintf("Hi!  I just stole some of your logged in time!");
		// The actual message
# Did we slim down on the steal amount?
			if ( is_null($original) )
		$message = sprintf("Just a friendly PM to tell you that I have stolen $steal_amount seconds of your total logged in time.  Bye!" );
			else
		$message = sprintf("Hi!  I tried to steal $original seconds of your logged in time; but you only had {$item_info[2]}, so I just took that instead.  Bye!");	
// Send the PM
		sendpm($pmto, $subject, $message, 0, $pmfrom);
					
		}
		else
	# Unsuccessful steal!
		{
			// If reducing Karma doesn't work, replace
			// 'karmaBad = karmaBad + 10' with 'karmaGood = karmaGood - 10'
			$result = db_query("
				UPDATE {$db_prefix}members
				SET karmaBad = karmaBad + {$item_info[4]}
				WHERE ID_MEMBER = {$ID_MEMBER}", __FILE__, __LINE__);
		   $return_message .= 'Steal <b>unsuccessful!</b>';
		# Do they get punished?
			if ($item_info[4] != 0)
		$return_message .= ' <br />Your ' . $karma . ' is now reduced by ' . $item_info[4] . '!  Doh!';
		}

		return $return_message;
	}


}

?>
